NIP-36
======

Sensitive Content / Content Warning
-----------------------------------

`draft` `optional` `author:fernandolguevara`

The `content-warning` tag enables users to specify if the event's content needs to be approved by readers to be shown.
Clients can hide the content until the user acts on it.

#### Spec

```
tag: content-warning
options:
 - [reason]: optional  
```

#### Example

```json
{
    "pubkey": "<pub-key>",
    "created_at": 1000000000,
    "kind": 1,
    "tags": [
      ["t", "hastag"],
      ["content-warning", "reason"] /* reason is optional */
    ],
    "content": "sensitive content with #hastag\n",
    "id": "<event-id>"
}
```
